% script for the SPMD example to remove noise from image

% read image file
x = imread('uol.jpeg');

% add noise and store noisy image
y = imnoise(x, 'salt & pepper', 0.30);
imwrite(y, 'uol_noisy.jpeg');

% distribute image (last column is color chanel)
yd = distributed(y);

% remove noise with filter in parallel
spmd
    yl    = getLocalPart(yd);
    yl    = medfilt2(yl, [3,3]);
end

% put together filtered image and store it
xdim = size(x);
z(1:xdim(1),1:xdim(2),1) = yl{1};
z(1:xdim(1),1:xdim(2),2) = yl{2};
z(1:xdim(1),1:xdim(2),3) = yl{3};
imwrite(z, 'uol_filter.jpeg')